/************************************************************************************
*                                                                                   *
*   File Name   : globals.h                                                         *
*   Contents    : Global Variables for Match Display                                *
*   Version     : 1.6                                                               *
*************************************************************************************/ 

//global defines
#define D_undefState 0
#define D_revDisplayState 1
#define D_gameDisplayState 2
#define D_matchDisplayState 3
#define D_chargeState 4
#define D_chargeFullState 5
#define D_battEmptyState 6

#define D_SHOW_REV_TIME_MS 3000
#define D_BATT_EMPTY_VOLTAGE_MV 10500
#define D_BATT_FULL_VOLTAGE_MV 13500
#define D_CHARGER_CONNECTED_VOLTAGE_MV 9000
#define D_CONV_AD_TO_MV(x) (unsigned int)(((unsigned long)(x)*(unsigned long)19644)/((unsigned long)1000)) //in real 760digits=14930mV=19.6447
#define D_CONV_DELTAU_CURR_MV_MA(x) ((unsigned int)((((((signed long)x-(signed long)720)*(signed long)1000)/(signed long)133)-2965)/(signed long)100)) //720mV 13.3R 29.65mA
#define D_CONV_CHG_STATE_PERCENT_CURR(x) (unsigned int)(((((signed long)x*(signed long)-40)+(signed long)1200)/(signed long)10))
#define D_DISP_OFF_SECONDS 5
#define D_TRUE  1
#define D_FALSE 0


//global variables
extern unsigned long UL_DISP_CODE;
extern unsigned int  UI_TIRQ_count1ms;
extern unsigned int  UI_int0_IRQ_timestamp;
extern unsigned int  UI_int1_IRQ_timestamp;
extern unsigned int  UI_STATE;
extern unsigned int  UI_CHARGE_STATE_PERCENT;
extern _Bool         B_SWITCH_PLAYER1;
extern _Bool         B_SWITCH_PLAYER2;
extern unsigned int  UI_BATTERY_VOLTAGE_MV;
extern unsigned int  UI_CHARGER_VOLTAGE_MV;
extern _Bool         B_DISP_OFF_CHG;
extern unsigned int  UI_DISP_OFF_CNT;

//global support functions
unsigned int timerDifference (unsigned int OLD, unsigned int NEW);
unsigned int positiveDifference (unsigned int A, unsigned int B);
